%-------------------------------------------------------------------------%
%                       VERTICAL RISER-SOIL MODEL (AUBENY)
%-------------------------------------------------------------------------%
%F arbRevBl til  bli tom, sette den lik null, gr det?
%i1, i fprintf, m ha i som input!!
% p i arbRev path, har p som ikke er brukt
%Penetration, z, positive downwards
clc 
clear
%Specified values
D = 0.3656;
phi_suc = 0.203;
shearStr_mudline = 800;
str_grad = 0;
ks = 65000;
w_assymp =0.433;
psi_soilSep = 0.661;
a_fit = 6.70;
b_fit =0.253;
alpha_fit = 0.07;
beta_fit = 0.3;
IOP = 2;

%Initial values
i = 0;
z_prev = 0.025;
z_prePrev =0.03;
p_prev = 0;
path = 100;
k0=0; % denne er jo spesifisert
p_rev1 =0;
p_rev2 = 0;
z_rev1 =0;
z_rev2=0;
z_rev3=0;
z_arbRevBl =0;
z_lastRev =0;
p_arbRevBl =0;
p_lastRev = 0;
lstart = 0;
z_max =0.25;

resz = zeros(1000,1);
resp = zeros(1000,1);
for lsnum = 1:1000
z = z_max*sin((2*pi*lsnum)/400);
%if lsnum>120
%    z = z_max*sin((2*pi*lsnum)/400)+0.00124278999;   
%end

switch IOP
case 1 
%LINEAR MODEL
%Linear springs
p = ks*z;
kz = ks;
path = 100;
%If soil separation occur, suction is not concidered
if z < 0
   path = 101;
end  

case 2
% NONLINEAR MODEL
if i <= 0 
    %Initial calculation
    p_prev = a_fit*(z_prev/D)^b_fit*(shearStr_mudline + str_grad*z_prev)*D;
    k0 = 660*shearStr_mudline;
    lstart = lsnum;
    path = 0;
end
  
%Check transition from linear to nonlinear
if i == 0
    if z<0 
        disp('There is no soil contact, try reducing the starting time')
        return
    end
end

%Load step
i = lsnum - (lstart -1);

%Initial penetration
if path == 0
    [p, kz, path] = path01(z, D, a_fit, b_fit, shearStr_mudline, str_grad);
end
%-------------------------------Reversals---------------------------------
%Define reversal points along bounding loop
if i>2
    if z< z_prev && z_prePrev<z_prev && path == 0  
        z_rev1 = z_prev;
        p_rev1 = p_prev;
        z_rev2 = z_rev1 - ((1+w_assymp)*p_rev1)/k0 * (1+phi_suc)/(w_assymp-phi_suc);
        p_rev2 = -phi_suc*p_rev1;
        z_rev3 = z_rev2 - psi_soilSep*(z_rev1-z_rev2);
        if z< z_rev2 && z> z_rev3 
            [p, kz, path] = path23(z, z_rev2, z_rev3, p_rev2);
        elseif z<z_rev3
            [p, kz, path] = path30();
        else 
            [p, kz, path] = path12(z, z_rev1, z_rev2, z_rev3, p_rev1,p_rev2, k0 ,w_assymp);
        end
    end
    % Reversal points when reloading on bounding loop
    if  z > z_prev && z>=z_rev3 && path == 30         
        lambda = z_rev1-z;
        z_rev1 = z_rev1 + alpha_fit*lambda^beta_fit;
        p_rev1 = a_fit*(z_rev1/D)^b_fit*(shearStr_mudline+str_grad*z_rev1)*D; 
        z_max = z_rev1;
       [p, kz, path] = path31(z, z_prev, z_rev1, z_rev2, z_rev3, p_rev1, p_rev2, p_prev,D,a_fit,b_fit,shearStr_mudline,str_grad, k0, w_assymp);    
    end
    if z > z_prev && (path == 12 || path == 23)
        z_arbRevBl = z_prev;
        p_arbRevBl = p_prev;
        lambda = z_rev1 - z_arbRevBl;
        z_rev1 = z_rev1 + alpha_fit*lambda^beta_fit;      
        p_rev1 = a_fit*(z_rev1/D)^b_fit*(shearStr_mudline+str_grad*z_rev1)*D;        
        z_max = z_rev1;
        if path == 12
          [p, kz, path, z_lastRev, p_lastRev] = path121(z, z_prev, z_rev1, z_rev2, z_rev3, z_arbRevBl, p_arbRevBl, p_rev1,p_rev2, p_prev, D,a_fit,b_fit,shearStr_mudline,str_grad,k0,w_assymp);
        end 
        if z > z_prev && path == 23       
            [p, kz, path]= path231(z, z_prev, z_rev1, z_rev2, z_rev3, z_arbRevBl, p_rev1, p_rev2, p_arbRevBl, p_prev, D, a_fit,b_fit,shearStr_mudline,str_grad, k0, w_assymp);
        end
    end
end

%------------------------Continiue on the same path-----------------------%
if path == 12
   [p, kz, path] = path12(z, z_rev1, z_rev2, z_rev3, p_rev1,p_rev2, k0 ,w_assymp);
end

if path == 121
    [p, kz, path, z_lastRev, p_lastRev] = path121(z, z_prev, z_rev1, z_rev2, z_rev3, z_arbRevBl, p_arbRevBl, p_rev1,p_rev2, p_prev, D,a_fit,b_fit,shearStr_mudline,str_grad,k0,w_assymp);
end

if path == 122
    [p, kz, path,  z_arbRevBl, p_arbRevBl] = path122(z, z_prev, z_rev1, z_rev2, z_rev3, z_lastRev, p_rev1, p_rev2, p_lastRev, p_prev, D, a_fit,b_fit,shearStr_mudline,str_grad, k0, w_assymp);
end

if path == 23
   [p, kz, path] = path23(z, z_rev2, z_rev3, p_rev2);
end

if path == 231
   [p, kz, path, z_lastRev, p_lastRev] = path231(z, z_prev, z_rev1, z_rev2, z_rev3, z_arbRevBl, p_rev1, p_rev2, p_arbRevBl, p_prev, D, a_fit,b_fit,shearStr_mudline,str_grad, k0, w_assymp);
end

if path == 30
   [p, kz, path] = path30();
end

if path == 31
  [p, kz, path] = path31(z, z_prev, z_rev1, z_rev2, z_rev3, p_rev1,p_rev2, p_prev, D,a_fit,b_fit,shearStr_mudline,str_grad, k0, w_assymp); 
end

%----------------------------- Updating parameters -----------------------------%
if i>2
    z_prePrev = z_prev;
end
z_prev = z;
p_prev = p;

%----------------------------- Updating result array --------------------------%
res(1:2) = [p,kz];
%Updating array for contact or separation
if path == 30 || path == 101
    res_contact = 0;
else 
    res_contact = 1;
end

resz(lsnum,1) = z;
resp(lsnum,1) = p;




end
plot(resz(:,1), resp(:,1))
axis([0 0.35 -600 2500])




end 
 